//**************************************Copyright 1999 James Tsao*
//
// Temperature Convertor v0.1
// Author: James Tsao (tsaojk@yahoo.com)
// Created: 29 Dec 1999
// Change History:
//   
//
//*********************************************************************

import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

/** The main applet class, contains all logic  */
public class tempConvApplet extends java.applet.Applet implements ActionListener {

   private Button theComputeButton_ = null;
	private Button theNewEntryButton_ = null;
   private TextField theCelsiusField_ = null;
	private TextField theFahrenheitField_ = null;
	private Label theCelsiusLabel_ = null;
	private Label theFahrenheitLabel_ = null;

	private MsgBox theMessage_ = null;


	double calculatedTemperature = 0;
	double userEnteredTemperature = 0;
	char unit;



   /** Applet Constructor -- need to put initialization code
	   which you don't want be executed when reloading. */
   public tempConvApplet() {
		theCelsiusField_ = new TextField(15);
		theFahrenheitField_ = new TextField(15);
	  theComputeButton_ = new Button("Convert");
		theNewEntryButton_ = new Button("New");
		theCelsiusLabel_ = new Label("CELSIUS          :");
		theFahrenheitLabel_ = new Label("FAHRENHEIT :");

		theMessage_ = new MsgBox(this,"Only one input allowed");
   }         
   /** Detect UI interactions - Event callbacks */
   public void actionPerformed(ActionEvent evt) {
	  // Handle the normal button actions
		if (evt.getSource() == theComputeButton_)
			computeSelected();
		else if (evt.getSource() == theNewEntryButton_)
			newSelected();
	}
/**
 * Insert the method's description here.
 * Creation date: (03/01/2000 23:00:55)
 */
public void closeMsgBox() {

	if (theMessage_ != null) theMessage_.dispose(); // Kill the frame
	  theMessage_ = null;
	
}
	/** Computes temperature, disables fields first, then calls 2 methods to get
   user input and calculate temperature */
   private void computeSelected() {
	  //String t = theCelsiusField_.getText(); // Get text to be published
	  theCelsiusField_.setEditable(false);
	  theFahrenheitField_.setEditable(false); // Clean up the input text area
		getUserInput();
		if (userEnteredTemperature != 99999) { // 99999 = invalid input error
			calculatedTemperature = computeTemperature(userEnteredTemperature, unit);
			displayResult();
		}
  }      
  /** Detects what unit has been entered, then calculates temperature */
	private double computeTemperature(double temp, char unit) {
	//calculation and display result
		if (unit == 'C') {
			return (temp/5 * 9) + 32;

		}
		else {
			return (temp - 32)/9 * 5;
		}

	}
   /** Cleaning up code goes here */
   public void destroy() {
   }   
  /*Displays the result in the correct field, with the correct decimal formatting */
  private void displayResult() {
  
	DecimalFormat decFormat = new DecimalFormat ("0.00");
 	
	if (unit == 'C')
  			theFahrenheitField_.setText(decFormat.format(calculatedTemperature));
  		else
  			theCelsiusField_.setText(decFormat.format(calculatedTemperature));
  }      
  /** Gets userInput, evaluates whether it is a Celsius value or Fahrenheit, or not valid*/
  private void getUserInput() {

		String s = null;
		Double aDouble = null;

		if  (theFahrenheitField_.getText().compareTo("") == 0)	{
  				s = theCelsiusField_.getText();
				unit = 'C';
				//System.out.println("CELSIUS");
		} else if (theCelsiusField_.getText().compareTo("") == 0) {
  				s = theFahrenheitField_.getText();
				unit = 'F';
				//System.out.println("FAH");
		} else {
	   			newSelected();			
				theMessage_.setBounds(0, 0, 150, 100); 		
				theMessage_.show();
				userEnteredTemperature = 99999; // 99999 = invalid user input
				return;
		
		}
		//Convert a string to the primitive type - double
		aDouble = new Double(s);
		userEnteredTemperature = aDouble.doubleValue();
  }                  
   /** Applet init method - will be executed when reloading */ 
	
	/*Set up a panel of buttons, and a panel of input TextFields */
   public void init() {
	  setLayout(new BorderLayout());
	  // The publish text area
	  Panel p1 = new Panel();
		p1.add(theCelsiusLabel_);
	 	p1.add(theCelsiusField_);
		p1.add(theFahrenheitLabel_);
		p1.add(theFahrenheitField_);
		add(p1, "Center");

	  // Main group of buttons
	  Panel p2 = new Panel();
	  p2.add(theComputeButton_);
		p2.add(theNewEntryButton_);
	  theComputeButton_.addActionListener(this);
	  theNewEntryButton_.addActionListener(this);
	  add(p2, "South");

   }      
   /** main
	  Used to run the Client without a Web Browser */
   public static void main(String args[]) {
	  Frame f = new Frame("Temperature Converter");
	  // Instantiate an instance of the Applet
	  tempConvApplet theClient = new tempConvApplet();
	  f.add(theClient, "Center");
	  f.setSize(300, 200);
		// The direct invocation of init is only safe when
		// no parameters are read via getParameter()
	  theClient.init();
	  theClient.start();
	  theClient.repaint();
	  f.show();
	}
   /** Clears all fields ready to process new entry, enables fields again */
   private void newSelected() {
	  theCelsiusField_.setText("");
	  theFahrenheitField_.setText(""); // Clean up the input text area
	  theCelsiusField_.setEditable(true);
	  theFahrenheitField_.setEditable(true); // Clean up the input text area
   }      
} // end of tempConvApplet class
